//this is MVector.cpp file
#include "Lowest.h"

#include "MVector.h"

//using namespace std;
//#include <iostream>

/* delete
real rand1(); // defined in Rando.cpp

MVector MVector::RandomMVector(void)
{  return MVector ( rand1(), rand1(), rand1());
}

void 
MVector::set_to_random_unit_MVector(void)
{ for(short i=0 ; i<VDIMENSION;i++) val[i] = rand1()-0.5;
}

void 
MVector::set_to_random(const MVector& size)
{ for(short i=0 ; i<VDIMENSION;i++)
    val[i] = size.val[i]*(rand1()-0.5);
}
*/
void MVector::print(const char *title) const
{
  cout<< title <<"= (";
  cout.precision(6);
  cout.setf(ios::right);
  cout<< val[0];
  for(short i=1 ; i<VDIMENSION;i++)
    cout<< ", "<<val[i];
  cout<< ")";
  cout<<endl;
  //cout.precision(DIGITS);
}

void MVector::print(ofstream& fstrm, char *title) const
{
  fstrm<<title<<"=(" <<val[0];
  fstrm<<", " <<val[1];
  fstrm<<", " <<val[2];
  fstrm<<")"<<endl;
}

MVector operator * (const real r, const MVector& rhs)
{   MVector prod;
    for(short i=0;i<VDIMENSION;i++) prod.val[i]=r*rhs.val[i];
	return prod;
}
ostream& operator<< (ostream& fout, const MVector& v) 
{ fout<<" "<<v.val[0]<<d_<<v.val[1]<<d_<<v.val[2];
  return fout;
}

istream& operator>> (istream& fin, MVector& v) {
  // was fin>>v.val[0]>>v.val[1]>>v.val[2];
	char c1[40];
  //cout<<"Next is:"<<fin.peek()<<endl;
  fin>>v.val[0];
  fin.getline(c1,39,d_); // get rid of comma
  //  cout<<"Next is:"<<fin.peek()<<endl;
  if(!fin.good()) 
	cout<<"Error reading vector "<<v<<"; did you forget a comma?"<<endl;
  fin>>v.val[1]; fin.getline(c1,39,d_); fin>>v.val[2];
  if(!fin.good()) 
	cout<<"Error2 reading vector "<<v<<"; did you forget a comma?"<<endl;
  return fin;
}

ostream& MVector::iv_print(ostream& fout) const{
  fout<<" "<<val[0]<<"  "<<val[1]<<"  "<<val[2]<<" ";
  return fout;
}

void int3::orient () // rearrange values so that 0<=values[i] <=values[i+1]
{
  for (short i=0; i<3; i++)
    values[i] = abs(values[i]);   //all numbers should be positive

//using bubble sorting:
  short temp; //temporary storage for swaping two numbers
  do {
    for (short i=0; i<2; i++)
      if (values[i] > values[i+1])  //need to swap them
      {
        temp = values[i];
        values[i] = values[i+1];
        values[i+1] = temp;
      }
  } while ((values[0] > values[1]) || (values[1] > values[2]));
  assert ((values[0] <= values[1]) && (values[1] <= values[2]));
}
   
//DMAk
//returns 1 if the values are (0,0,0)
bool int3::isZero() const
{
  return ((values[0]==0) && (values[1]==0) && (values[2]==0));
}

ostream& operator<<(ostream &out, const int3 &i) //overloaded <<operator for int3 class
{
  out<<" ("<<i.values[0]<<' '<<i.values[1]<<' '<<i.values[2]<<") ";
  return out;
}


int3 int3::operator- (const int3& iRight) const
{ int3 result;
  for (short i=0; i<3; i++)
    result.values[i] = values[i] - iRight.values[i];
  return result;
}

int3 int3::operator+ (const int3& iRight) const
{ int3 result;
  for (short i=0; i<3; i++)
    result.values[i] = values[i] + iRight.values[i];
  return result;
}

int3 int3::operator/ (const short& r) const
{ int3 result;
  for (short i=0; i<3; i++)
  {
    assert ((values[i]%r) == 0);
    result.values[i] = values[i]/r;
  }
  return result;
}

const int3 & int3::operator= (const int3& right)
{ for (short i = 0; i<3; i++)values[i] = right.values[i];
  return *this;
}
