// This is Average.C file
#include "Lowest.h"
#include "Outputs.h"
#include "Systm.h"
extern Systm* My;

real *Average::val = new real[Max_N];

void Average::init()
{
  NSamp = 0;
  //double loop over i&j computes composite index(ij)
  for (short i=0; i<N; i++)  Avg[i]=0;
}

void Average::increment()
{
  //accumulates val into Avg and Avg2
  NSamp++;
  for (short i=0; i<N; i++)
   { 
     Avg[i] += val[i]; 
     //My->Avgout.precision(8);
     //if(i == 3) My->Avgout<<" "<<val[i]<<" ";
    }
}

void Average::normalize()
{
  //divide out number of samples
  for (short i=0; i<N; i++)
   { Avg[i] /= NSamp; }
}

void Average::WriteandInit()
{
  normalize();
  for (short i=0; i<N; i++)
  {
   My->Avgout.precision(8);
   //if(i ==3) My->Avgout<<" "<<Avg[i]<<" "; 
   My->Avgout<<" "<<Avg[i]<<" ";
   }
  init();
}

Integrals::Integrals(short Num1 = 2): NumInt(Num1)
{ // (short Num1 = 2) means Num1 set to 2 if no argument given
  // NumInt(Num1) sets NumInt=Num1 (can't do this directly because NumInt is const)
	ValInt = new real [NumInt];
} //constructor initialize const short member


void Integrals::InitializeInt(void) //clear all the integrals
{ // can't be done in constructor, needs to be done EVERY time we compute them
	for(short i=0; i<NumInt; i++) ValInt[i]=0.;
}

/* BROKEN
Magnetoresistance::Magnetoresistance(Rectang* Rect0_in,Rectang* Rect1_in) // constructor
{
  Rect0 = Rect0_in; Rect1 = Rect1_in;
}
*/
