#ifndef CONFIG_H
#define CONFIG_H

//#include "Lowest.h"
#include "cell.h"
#include <fstream>
#include "MVector.h"

class Config{
public:
	MVector *ConfigArr;
    Config(); // constructor
Config(const Config&);
	Config(const MVector&);
	void restore(void); // deprecated?
	void restoreAnd(void); // &renorm,Calc fields
	void saveM(void);
	void print();
	void ProjectOut(Config C1);
	void saveDelM(void);
	real diff(Config&, Config&); // not implemented; use operator - instead
	real norm(void) const; // NOT weighted by volume!
	void ExporttoFile(ofstream&); // superseded by operator<<?
	void ImportfromFile(ifstream&);	
    void writeBinary(ofstream&);
    void readBinary(ifstream&);
  friend ostream& operator<< (ostream&, const Config&); 
  friend std::istream& operator>> (std::istream&, Config&); 
	Config& operator += (const Config&);
	Config& operator -= (const Config&);
	Config& operator *= (const real);
	MVector& operator[] (int);
	friend Config operator + (const Config lhs, const Config rhs);
	friend Config operator - (const Config lhs, const Config rhs);
	friend Config operator * (const real, const Config&);
	friend real operator * (const Config& lhs, const Config& rhs);
};
#endif
