#ifndef ACPULSE_H
#define ACPULSE_H

//#include "Lowest.h"
#include "MVector.h"
#include <fstream>
// #include <unistd.h> // for exit
class ACPulsedField
{
 public:
    short mode; //mode of the AC pulse field change
	enum SweepMode {Log, Linear, Constant} mymode;
	MVector Hcos;
	MVector Hsin;

	real omega;
	real omega_start; //AC pulse field minimal circular frequency
	real omega_rate;
	real omega_end; //AC pulse field maximal circular frequency
	real omega_step;
	real theta; //initial phase of the AC pulse field
	real StartTime; //start time
	real TotalTime; //total time

    // member functions 
	ACPulsedField();
	~ACPulsedField();
    void ReadAC(ifstream *File);
    MVector GetACField();
};

#endif